Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.

Bug 2032701

Summary: [F36FTBFS]: freeipa fails to build from source in Fedora Rawhide with openldap-2.6
Product: [Fedora] Fedora Reporter: Simon Pichugin <spichugi>
Component: freeipaAssignee: Alexander Bokovoy <abokovoy>
Status: CLOSED ERRATA QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: unspecified Docs Contact:
Priority: unspecified    
Version: rawhideCC: abokovoy, frenaud, ftrivino, ipa-maint, jcholast, jhrozek, mhjacks, pvoborni, rcritten, ssorce, twoerner
Target Milestone: ---Keywords: Triaged
Target Release: ---   
Hardware: Unspecified   
OS: Unspecified   
Whiteboard:
Fixed In Version: freeipa-4.9.8-2.fc36 Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2022-01-12 07:31:04 UTC Type: Bug
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Embargoed:
Bug Depends On:    
Bug Blocks: 2021662    

Description Simon Pichugin 2021-12-15 02:37:41 UTC
Your package fails to build with the newest openldap-2.6, which was part of a recent wide Fedora change. More information about Fedora OpenLDAP Change is available here: https://fedoraproject.org/wiki/Changes/Openldap_25#How_To_Test.
Thank you for your cooperation!

Additional Information:
If you have an issue with libldap_r depreciation, you can use the following example for fixing your package:
https://github.com/389ds/389-ds-base/commit/a3375a08a506c3b72a8a23df5238848017691350

Comment 1 Alexander Bokovoy 2022-01-11 13:42:52 UTC
For the record, failed build was https://copr.fedorainfracloud.org/coprs/spichugi/openldap-2.6/build/3018338/

but that one is not available anymore.

I tried the re-run in mock environment as described in the change link Simon provided and the first failure is exactly libldap_r deprecation:

checking if gcc supports -fno-rtti -fno-exceptions... no
checking for gcc option to produce PIC... -fPIC -DPIC
checking if gcc PIC flag -fPIC -DPIC works... yes
checking if gcc static flag -static works... no
checking if gcc supports -c -o file.o... yes
checking if gcc supports -c -o file.o... (cached) yes
checking whether the gcc linker (/usr/bin/ld -m elf_x86_64) supports shared libraries... yes
checking whether -lc should be explicitly linked in... no
checking dynamic linker characteristics... GNU/Linux ld.so
checking how to hardcode library paths into programs... immediate
checking whether stripping libraries is possible... yes
checking if libtool supports shared libraries... yes
checking whether to build shared libraries... yes
checking whether to build static libraries... no
checking for egrep... (cached) /usr/bin/grep -E
checking for x86_64-redhat-linux-gnu-pkg-config... /usr/bin/x86_64-redhat-linux-gnu-pkg-config
checking pkg-config is at least version 0.9.0... yes
checking for POPT... yes
checking for KRB5... yes
checking for KRB5_GSSAPI... yes
checking for kdb.h... yes
checking for kdb_vftabl.free_principal... no
configure: KDB driver API has no free_principal callback
checking for kdb_vftabl.free_principal_e_data... yes
checking for ldap_search in -lldap_r... no
configure: error: libldap_r not found


RPM build errors:
error: Bad exit status from /var/tmp/rpm-tmp.YvOT7T (%build)
    Bad exit status from /var/tmp/rpm-tmp.YvOT7T (%build)
Finish: rpmbuild freeipa-4.9.8-1.fc35.src.rpm
Finish: build phase for freeipa-4.9.8-1.fc35.src.rpm
ERROR: Exception(./freeipa-4.9.8-1.fc35.src.rpm) Config(spichugi-openldap-2.6_fedora-rawhide-x86_64) 2 minutes 9 seconds
INFO: Results and/or logs in: /var/lib/mock/spichugi-openldap-2.6_fedora-rawhide-x86_64/result


I'll work on this as I have it reproduced.

Comment 2 Alexander Bokovoy 2022-01-11 14:23:23 UTC
Upstream PR: https://github.com/freeipa/freeipa/pull/6134

Comment 3 Alexander Bokovoy 2022-01-11 14:34:58 UTC
With the fix:

checking pkg-config is at least version 0.9.0... yes
checking for POPT... yes
checking for KRB5... yes
checking for KRB5_GSSAPI... yes
checking for kdb.h... yes
checking for kdb_vftabl.free_principal... no
configure: KDB driver API has no free_principal callback
checking for kdb_vftabl.free_principal_e_data... yes
checking for library containing ldap_search... -lldap
checking for library containing ber_peek_tag... -llber
checking for main in -lresolv... yes
checking for resolv.h... yes
checking for CRYPTO... yes
checking for PWQUALITY... yes
configure: Python user override detected, /usr/bin/python3
configure: Checking for platform Python

..

Provides: config(freeipa-server) = 4.10.0.dev202201111415+git2a6e05893-0.fc36 freeipa-server = 4.10.0.dev202201111415+git2a6e05893-0.fc36 freeipa-server(x86-64) = 4.10.0.dev202201111415+git2a6e05893-0.fc36 ipa-server = 4.10.0.dev202201111415+git2a6e05893 libipa_dns.so()(64bit) libipa_enrollment_extop.so()(64bit) libipa_extdom_extop.so()(64bit) libipa_lockout.so()(64bit) libipa_modrdn.so()(64bit) libipa_otp_counter.so()(64bit) libipa_otp_lasttoken.so()(64bit) libipa_pwd_extop.so()(64bit) libipa_range_check.so()(64bit) libipa_repl_version.so()(64bit) libipa_sidgen.so()(64bit) libipa_sidgen_task.so()(64bit) libipa_uuid.so()(64bit) libipa_winsync.so()(64bit) libtopology.so()(64bit)
Requires(interp): /bin/sh /bin/sh /bin/sh /bin/sh
Requires(rpmlib): rpmlib(CompressedFileNames) <= 3.0.4-1 rpmlib(FileDigests) <= 4.6.0-1 rpmlib(PayloadFilesHavePrefix) <= 4.0-1
Requires(pre): /bin/sh 389-ds-base >= 2.0.7-1 certmonger >= 0.79.7-3 shadow-utils systemd-units >= 246.6-3
Requires(post): /bin/sh krb5-server >= 1.18.2-29 krb5-server >= 1.19 selinux-policy-base >= 3.14.5-45 systemd-units >= 246.6-3
Requires(preun): /bin/sh python3 systemd-units >= 246.6-3
Requires(postun): python3 systemd-units >= 246.6-3
Requires(posttrans): /bin/sh
Requires: /usr/bin/python3 /usr/bin/sh libc.so.6()(64bit) libc.so.6(GLIBC_2.14)(64bit) libc.so.6(GLIBC_2.2.5)(64bit) libc.so.6(GLIBC_2.25)(64bit) libc.so.6(GLIBC_2.3)(64bit) libc.so.6(GLIBC_2.3.4)(64bit) libc.so.6(GLIBC_2.34)(64bit) libc.so.6(GLIBC_2.4)(64bit) libc.so.6(GLIBC_2.7)(64bit) libc.so.6(GLIBC_2.8)(64bit) libcom_err.so.2()(64bit) libcrypto.so.3()(64bit) libcrypto.so.3(OPENSSL_3.0.0)(64bit) libgcc_s.so.1()(64bit) libgcc_s.so.1(GCC_3.0)(64bit) libgcc_s.so.1(GCC_3.3.1)(64bit) libgssapi_krb5.so.2()(64bit) libgssapi_krb5.so.2(gssapi_krb5_2_MIT)(64bit) libk5crypto.so.3()(64bit) libk5crypto.so.3(k5crypto_3_MIT)(64bit) libkrad.so.0()(64bit) libkrad.so.0(krad_0_MIT)(64bit) libkrb5.so.3()(64bit) libkrb5.so.3(krb5_3_MIT)(64bit) liblber.so.2()(64bit) liblber.so.2(OPENLDAP_2.200)(64bit) libldap.so.2()(64bit) libldap.so.2(OPENLDAP_2.200)(64bit) libndr-krb5pac.so.0()(64bit) libndr-krb5pac.so.0(NDR_KRB5PAC_0.0.1)(64bit) libndr-standard.so.0()(64bit) libndr.so.2()(64bit) libndr.so.2(NDR_0.0.1)(64bit) libpopt.so.0()(64bit) libpopt.so.0(LIBPOPT_0)(64bit) libpwquality.so.1()(64bit) libpwquality.so.1(LIBPWQUALITY_1.0)(64bit) libsamba-errors.so.1()(64bit) libsamba-errors.so.1(SAMBA_ERRORS_1)(64bit) libsamba-util.so.0()(64bit) libsamba-util.so.0(SAMBA_UTIL_0.0.1)(64bit) libsss_certmap.so.0()(64bit) libsss_certmap.so.0(SSS_CERTMAP_0.0)(64bit) libsss_nss_idmap.so.0()(64bit) libsss_nss_idmap.so.0(SSS_NSS_IDMAP_0.1.0)(64bit) libsss_nss_idmap.so.0(SSS_NSS_IDMAP_0.4.0)(64bit) libtalloc.so.2()(64bit) libtalloc.so.2(TALLOC_2.0.2)(64bit) libtevent.so.0()(64bit) libunistring.so.2()(64bit) libuuid.so.1()(64bit) libuuid.so.1(UUID_1.0)(64bit) libverto.so.1()(64bit) rtld(GNU_HASH)
Conflicts: ipa-server nss-pam-ldapd < 0.8.4
Obsoletes: freeipa-server <= 4.2.0 freeipa-server-selinux < 3.3.0 ipa-server < 4.10.0.dev202201111415+git2a6e05893
Processing files: python3-ipaserver-4.10.0.dev202201111415+git2a6e05893-0.fc36.noarch

Comment 4 Rob Crittenden 2022-01-11 20:21:27 UTC
Fixed upstream
master:
https://pagure.io/freeipa/c/f0191040616e6fe58fef5b20b7d9c284de913be7

Comment 5 Fedora Update System 2022-01-12 07:28:41 UTC
FEDORA-2022-1ef04bd095 has been submitted as an update to Fedora 36. https://bodhi.fedoraproject.org/updates/FEDORA-2022-1ef04bd095

Comment 6 Fedora Update System 2022-01-12 07:31:04 UTC
FEDORA-2022-1ef04bd095 has been pushed to the Fedora 36 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 7 Florence Blanc-Renaud 2022-01-12 10:20:06 UTC
Fixed upstream:
ipa-4-9:
https://pagure.io/freeipa/c/ce112e68bd711199baee1f7103d31a4bb0c5ad97